/**
 * ajax请求处理及保存配置到本地数据库
 **/
(function($, owner) {
	/**
	 * 连接服务器
	 **/
	owner.connect = function(url, success, error) {
		$.ajax({  
			async: true,
		    type: "GET",  
			url: url, 
			dataType: 'json',
			timeout: 10000,
			success: success,
			error: error
		});
	};
	
	owner.connect = function(url, success, error, timeout) {
		$.ajax({  
			async: true,
		    type: "GET",  
			url: url, 
			dataType: 'json',
			timeout: timeout,
			success: success,
			error: error
		});
	};
	/**
	 * POST请求
	 **/
	owner.ajaxPost = function(url, data, success, error) {
		$.ajax({  
			async: true,
		    type: "POST",  
			url: url, 
			dataType: 'json',
			data: data,
			timeout: 5000,
			success: success,
			error: error
		});
	};

	/**
	 * 设置应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		//console.log("set settings::"+JSON.stringify(settings));
		localStorage.setItem('$settings', JSON.stringify(settings));
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.getSettings = function() {
			var settingsText = localStorage.getItem('$settings') || "{}";
		    //console.log("get settings::"+settingsText);
			return JSON.parse(settingsText);
	};

	/**
	 * 设置语言
	 */
    owner.updateLanguage = function(langValue, callbackFunc) {
    	jQuery.i18n.properties({
	        name: 'strings',
	        path: 'i18n/', //资源文件路径
	        mode: 'map', //用Map的方式使用资源文件中的值
	        language: langValue,
	        callback: callbackFunc
		});
	};
	
	/**
	 * 设置当前活动窗口（用作全局变量）
	 **/
	owner.setActiveView = function(view) {
		view = view || "";
		localStorage.setItem('$activeview', view);
	};

	/**
	 * 获取当前活动窗口（用作全局变量）
	 **/
	owner.getActiveView = function() {
			var activeview = localStorage.getItem('$activeview') || "";
			return activeview;
	};
	
}(mui, window. app = {}));