var connecting = false; //连接中
var connected = false; // 是否已连接成功
var waiting=null; //等待对象
var settings = null; //保存到localStorage的设定对象
var lang = null; //语言选项
var pageLoadDelay = 0; //首次自动连接时需加额外的delay时间等待list页面加载完毕才能调用init函数
mui.plusReady(function() {
	plus.screen.lockOrientation("portrait-primary");
	jQuery.ajaxSetup({cache:false});
	settings = app.getSettings();
	app.setActiveView("");
	initLanguage();
	app.updateLanguage(lang, updateLanguage);
	var mainPage = mui.preload({
		"id": 'main',
		"url": 'main.html'
	});
	var toMain = function(response) {
		mui.fire(mainPage, 'show', null);
		mui.openWindow({
			id: 'main',
			show: {
				aniShow: 'pop-in'
			},
			waiting: {
				autoShow: true
			},
		});
		setTimeout(function() {
			mui.fire(mainPage, 'init', null);
		}, pageLoadDelay/2+100);
		setTimeout(function() {
			mui.fire(plus.webview.getWebviewById('list'), 'init', {data:response});
		}, pageLoadDelay+200);
		//plus.webview.currentWebview().hide('auto');

	};
					
	// close splash
	setTimeout(function() {
		//关闭 splash
		plus.navigator.closeSplashscreen();
	}, 0);

	var scanButton = document.getElementById("barBtn");
	var connectButton = document.getElementById('connectBtn');
	var urlBox = document.getElementById('url');
	var autoConnectButton = document.getElementById("autoConnect");

	if(settings.url != null)
		urlBox.value = settings.url;
						
	var connectToServer = function() {
		if(connecting)
			return;
		var url = urlBox.value;	
		if (url.length == 0) {
			plus.nativeUI.toast(jQuery.i18n.prop('error.blankurl'));
		}
		if(plus.networkinfo.getCurrentType()==plus.networkinfo.CONNECTION_NONE){
			plus.nativeUI.toast(jQuery.i18n.prop('no.network'));
		    pageLoadDelay = 0;
		}else{
			app.connect(url+'/appList', success, error);
			connected = false;	
			connecting = true;
			waiting=plus.nativeUI.showWaiting();

			//保存URL到本地存储
			settings.url = url;
		    app.setSettings(settings);

		}
	};
					
	/**
	* 成功响应的回调函数
	*/
	var success = function(response) {
		//console.log('连接成功::'+JSON.stringify(response));

		closeWaiting();
		toMain(response);
		connecting = false;
		connected = true;
		pageLoadDelay = 0;
	};
	
	/**
	* 失败响应的回调函数
	*/
	var error = function(result) {
		plus.nativeUI.toast(jQuery.i18n.prop('connect.fail'));
		//console.log("connect error: "+result.status);
		connecting = false;
		connected = false;
		closeWaiting();
		pageLoadDelay = 0;
	};
	
	/**
	* 关闭等待框
	*/
	var closeWaiting=function(){
		waiting&&waiting.close();
		waiting=null;
	}
	scanButton.addEventListener('tap', scanBarcode);
	connectButton.addEventListener('tap', connectToServer);
	autoConnectButton.classList[settings.autoConnect ? 'add' : 'remove']('mui-active')
	autoConnectButton.addEventListener('toggle', function(event) {
		setTimeout(function() {
			var isActive = event.detail.isActive;
			settings.autoConnect = isActive;
			app.setSettings(settings);
		}, 50);
	}, false);
	//
	var backButtonPress = 0;
	mui.back = function(event) {
		backButtonPress++;
		if (backButtonPress > 1) {
			plus.runtime.quit();
		} else {
			plus.nativeUI.toast(jQuery.i18n.prop('press.to.exit'));
		}
		setTimeout(function() {
			backButtonPress = 0;
		}, 10000);
		return false;
	};
					
	document.querySelector('.mui-table-view.mui-table-view-radio').addEventListener('selected',function(e){
		selectLanguage(e.detail.el.id);
	});
					
	//检查 "连接状态" 开始
	if (settings.autoConnect) {
		pageLoadDelay = 2000;
		connectToServer();
	} 
});
				
// 扫描二维码
var openw=null;
function scanBarcode() {
	if(openw){//避免多次打开同一个页面
		return;
	}
	openw=plus.webview.create('barcode_scan.html','barcode_scan.html',null);
	openw.addEventListener('loaded',function(){//页面加载完成后才显示
		openw.show('pop-in');
			//closeWaiting();
	},false);
	openw.addEventListener('close',function(){//页面关闭后可再次打开
		openw=null;
	},false);
}
function scaned( t, r, f ) {
	document.getElementById('url').value = r;
}
function selectLanguage(value) {
	lang = value;
	settings.lang = lang;
	app.setSettings(settings);
	app.updateLanguage(lang, updateLanguage);
}
		
function updateLanguage() {
	document.getElementById('langlabel').innerHTML = jQuery.i18n.prop('language');
	document.getElementById('connectlabel').innerHTML = jQuery.i18n.prop('autoconnect');
	document.getElementById('version').innerHTML = jQuery.i18n.prop('version');
	document.getElementById('url').setAttribute('placeholder', jQuery.i18n.prop('connect.url'));
	document.getElementById('lang').innerHTML = document.getElementById(lang).innerText;
}
				
//初始化语言
function initLanguage() {
	if(settings.lang != null) {
		lang = settings.lang;
	} else {
		if(document.getElementById(plus.os.language) != null) {
			lang = plus.os.language;
		}else{
			lang = 'en';
		}
		settings.lang = lang;
		app.setSettings(settings);
	}
	document.getElementById(lang).setAttribute("class","mui-table-view-cell mui-selected");
}
				
