var isLogin = false;
var control = null;
var index;
mui.plusReady(function() {
	//自定义事件, 有新的ajax数据包时更新显示
    window.addEventListener('updateUI',function(event){
    	//获得事件参数
        var resp = event.detail.resp;
        updateUI(resp);
	});	
	//自定义事件, 进入detail页面时初始化一次
	window.addEventListener('init',init);
	//自定义事件, 显示子页面前的初始化
	window.addEventListener('initShow',initShow);
	//自定义事件, 当监控设备变更时调用，snmp和local的控制不一样
	window.addEventListener('onDeviceChanged',onDeviceChanged);
	//事件监听
	document.getElementById("snmpTestBtn").addEventListener('tap', function(e){
		goToSnmpTest();
	});
	document.getElementById("quicktestBtn").addEventListener('tap', function(){
		submitTest();
	});
});

/**
* @param {Object} resp: ajax取得的新数据
*/
function updateUI(resp) {
	document.getElementById('quicktestLabel').innerHTML = jQuery.i18n.prop('battest.quicktest');
	document.getElementById('quicktestBtn').innerHTML = jQuery.i18n.prop('battest.test');
	document.getElementById('snmptestLabel').innerHTML = jQuery.i18n.prop('battest.link');
}
function initShow() {
	goToControl();
}
function init() {
    isLogin = false;
    control = null;
    index = event.detail.index;
	app.updateLanguage(app.getSettings().lang, updateLanguage);
}

function onDeviceChanged() {
    isLogin = false;
    control = null;
}

function goToControl() {
	document.getElementById("battest").style.display="none";
	document.getElementById("snmptest").style.display="none";
	if(isLogin) {
		document.getElementById("battest").style.display="block";
	}else{
		if(control == null) {
			var url = app.getSettings().url+'/'+index+'/appControl';
			app.connect(url, controlCallbackSuccess, controlCallbackError);
		}else{
			toControl();
		}
	}
}
function toControl() {
	if(control.protocol == 99) {
		document.getElementById("battest").style.display="none";
		document.getElementById("snmptest").style.display="block";
	}else{
		login();
	}
}
function goToSnmpTest() {
	if(control.oidType == 7) {
		plus.runtime.openURL('http://'+control.ip+'/management/ups_battery_test.html');
	}else if(data.oidType == 1) {
		plus.runtime.openURL('http://'+control.ip+'/Page/PageBatteryT.html');
	}
}
function login() {
	popupPrompt(jQuery.i18n.prop('enter.password'));
}
function popupPrompt(title) {
	var btnArray = [jQuery.i18n.prop('button.cancel'), jQuery.i18n.prop('button.ok')];
	mui.prompt('', '', title, btnArray, function(e) {
		if (e.index == 1) {
			var url = app.getSettings().url+'/appLogin';
			var data = {'password':e.value};
			app.ajaxPost(url, data, loginCallbackSuccess, loginCallbackError);
		} else {
		}
	},'div');
	document.querySelector('.mui-popup-input input').type='password';
}
var controlCallbackSuccess = function(resp) {
	control = resp;
	goToControl();

}
var controlCallbackError = function(result) {
}
var loginCallbackSuccess = function(resp) {
	if(resp.isLogin) {
		isLogin = resp.isLogin;	
		showLocalTest();
	}else{
		popupPrompt(jQuery.i18n.prop('incorrect.password'));
	}
}
var loginCallbackError = function(result) {
}

function showLocalTest() {
	document.getElementById("battest").style.display="block";
}

function submitTest() {
	var url = app.getSettings().url+'/'+index+'/appTest';
	var data = {"action":"tq","time":10};
	app.ajaxPost(url, data, testCallbackSuccess, testCallbackError);
	plus.nativeUI.toast(jQuery.i18n.prop('command.send'));
}

var testCallbackSuccess = function(resp) {
	setTimeout(reload, 2000);
}

var testCallbackError = function(result) {
}

function updateLanguage() {
}