var loadPage, batteryPage;
var timerCounter = 0; //每reload一次加1(10秒)，用于控制input和bypass数据的轮流显示
mui.plusReady(function() {
	loadPage = mui.preload({
		url:"load.html",
		id:"load",
	});
	batteryPage = mui.preload({
		url:"battery.html",
		id:"battery",
	});
	mui(".sb5_1").on("tap", "a", function() {
		mui.openWindow({
			id: 'load',
			"url":"load.html"
		});
    	mui.fire(loadPage,'init',null);
	});
   
	mui(".sb5_2").on("tap", "a", function() {
		mui.openWindow({
			id: 'battery',
			"url":"battery.html"
		});
    	mui.fire(batteryPage,'init',null);
	});
	
	//自定义事件, 有新的ajax数据包时更新显示
    window.addEventListener('updateUI',function(event){
    	//获得事件参数
        var resp = event.detail.resp;
        updateUI(resp);
	});	
	//自定义事件, 进入detail页面时初始化一次
	window.addEventListener('init',init);
	//自定义事件, 显示子页面前的初始化
	window.addEventListener('initShow',initShow);
});

function initShow() {
}
function init() {
	timerCounter = 0;
	app.updateLanguage(app.getSettings().lang, updateLanguage);
}

/**
* @param {Object} resp: ajax取得的新数据
*/
function updateUI(resp) {
	var modeString = document.getElementById("modeString");
	var modeIcon = document.getElementById("modeIcon");
	modeIcon.setAttribute("src","images/"+resp.modeIcon+".png");
	modeString.innerHTML = resp.modeString;
	var invs = toArray(resp.inVolt);
	var inf = resp.inFreq;
	var bpsvs = toArray(resp.bpsVolt);
	var bpsf = resp.bpsFreq;
	var outvs = toArray(resp.outVolt);
	var outf = resp.outFreq;
	var outas = toArray(resp.outA);
	var inPhase = invs.length;
	var outPhase = outvs.length;
	var bpsPhase = bpsvs.length;
	//update output group
	if(outPhase >= 2) {
		document.getElementById("out1").style.display="none";
		document.getElementById("out3").style.display="block";
		document.getElementById("out3_v1").innerHTML = outvs[0];
		document.getElementById("out3_v2").innerHTML = outvs[1];
		document.getElementById("out3_f1").innerHTML = cv(outf);
		document.getElementById("out3_f2").innerHTML = cv(outf);
		document.getElementById("out3_a1").innerHTML = cv(outas[0]);
		document.getElementById("out3_a2").innerHTML = cv(outas[1]);
		if(outPhase == 3) {
			document.getElementById("out3_v3").innerHTML = outvs[2];
			document.getElementById("out3_f3").innerHTML = cv(outf);
			document.getElementById("out3_a3").innerHTML = cv(outas[2]);
		}else{
			document.getElementById("out3_v3").innerHTML = "";
			document.getElementById("out3_f3").innerHTML = "";
			document.getElementById("out3_a3").innerHTML = "";
		}
		
	}else {
		document.getElementById("out1").style.display="block";
		document.getElementById("out3").style.display="none";
		document.getElementById("out1_v").innerHTML = outvs[0];
		document.getElementById("out1_f").innerHTML = cv(outf);
		document.getElementById("out1_a").innerHTML = cv(outas[0]);
		
	}
	//update input group
	if(resp.bpsVolt.length > 0 && timerCounter % 2 == 1) {
		document.getElementById('input1').innerHTML = jQuery.i18n.prop('group.bps');
		document.getElementById('input3').innerHTML = jQuery.i18n.prop('group.bps');
		if(bpsPhase >= 2) {
			document.getElementById("in1").style.display="none";
			document.getElementById("in3").style.display="block";
			document.getElementById("in3_v1").innerHTML = bpsvs[0];
			document.getElementById("in3_v2").innerHTML = bpsvs[1];
			document.getElementById("in3_f1").innerHTML = cv(bpsf);
			document.getElementById("in3_f2").innerHTML = cv(bpsf);
			if(bpsPhase == 3) {
				document.getElementById("in3_v3").innerHTML = bpsvs[2];
				document.getElementById("in3_f3").innerHTML = cv(bpsf);
			}else{
				document.getElementById("in3_v3").innerHTML = "";
				document.getElementById("in3_f3").innerHTML = "";
			}
		}else{
			document.getElementById("in1").style.display="block";
			document.getElementById("in3").style.display="none";
			document.getElementById("in1_v").innerHTML = bpsvs[0];
			document.getElementById("in1_f").innerHTML = cv(bpsf);
		}
	}else {
		document.getElementById('input1').innerHTML = jQuery.i18n.prop('group.in');
		document.getElementById('input3').innerHTML = jQuery.i18n.prop('group.in');
		if(inPhase >= 2) {
			document.getElementById("in1").style.display="none";
			document.getElementById("in3").style.display="block";
			document.getElementById("in3_v1").innerHTML = invs[0];
			document.getElementById("in3_v2").innerHTML = invs[1];
			document.getElementById("in3_f1").innerHTML = cv(inf);
			document.getElementById("in3_f2").innerHTML = cv(inf);
			if(inPhase == 3) {
				document.getElementById("in3_v3").innerHTML = invs[2];
				document.getElementById("in3_f3").innerHTML = cv(inf);
			}else{
				document.getElementById("in3_v3").innerHTML = "";
				document.getElementById("in3_f3").innerHTML = "";
			}
		}else{
			document.getElementById("in1").style.display="block";
			document.getElementById("in3").style.display="none";
			document.getElementById("in1_v").innerHTML = invs[0];
			document.getElementById("in1_f").innerHTML = cv(inf);
		}
	}
	//load
	var loadpercent = resp.loadPercentMax;
	var loadAlarm = resp.loadAlarm;
	var loadP = document.getElementById("loadP");
	var loadImg = document.getElementById("loadImg");
	loadP.innerHTML = loadpercent+"%";
	var loadImgName = "images/fuzai_";
	loadImgName = loadImgByPercent(loadImgName, loadpercent);
	if(loadAlarm) {
		loadP.setAttribute("class","sb5_2_1");
		loadImg.setAttribute("src",loadImgName+"y.png");
	}else{
		loadP.setAttribute("class","sb5_1_1");
		loadImg.setAttribute("src",loadImgName+".png");
	}
	//battery
	var batCapacity = resp.batCapacity;
	var batAlarm = resp.batAlarm;
	var batC = document.getElementById("batC");
	var batImg = document.getElementById("batImg");
	batC.innerHTML = batCapacity+"%";
	var batImgName = "images/dianchi_";
	batImgName = loadImgByPercent(batImgName, batCapacity);
	if(batAlarm) {
		batC.setAttribute("class","sb5_2_1");
		batImg.setAttribute("src",batImgName+"y.png");
	}else{
		batC.setAttribute("class","sb5_1_1");
		batImg.setAttribute("src",batImgName+".png");
	}
	var param = {"resp": resp};
	//loadPage
	mui.fire(loadPage, 'updateUI',param );
	//batteryPage
	mui.fire(batteryPage, 'updateUI',param);
	timerCounter++;
}
function cv(value) {
	if(value.length == 0)
		return "--";
	return value;	
}
function toArray(valS) {
	return valS.split("/");
}
function loadImgByPercent(imgName, value) {
	var ret = imgName;
	if(value <= 0) {
		ret +="0";
	}else if(value < 16) {
		ret +="1";
	}else if(value < 36) {
		ret += "2";
	}else if(value < 56) {
		ret += "3";
	}else if(value < 76) {
		ret += "4";
	}else if(value < 96) {
		ret += "5";
	}else{
		ret += "6";
	}
	return ret;
}

function updateLanguage() {
	document.getElementById('output1').innerHTML = jQuery.i18n.prop('group.out');
	document.getElementById('outVolt1').innerHTML = jQuery.i18n.prop('volt');
	document.getElementById('outFreq1').innerHTML = jQuery.i18n.prop('freq');
	document.getElementById('outCur1').innerHTML = jQuery.i18n.prop('current');
	document.getElementById('output3').innerHTML = jQuery.i18n.prop('group.out');
	document.getElementById('outVolt3').innerHTML = jQuery.i18n.prop('volt');
	document.getElementById('outFreq3').innerHTML = jQuery.i18n.prop('freq');
	document.getElementById('outCur3').innerHTML = jQuery.i18n.prop('current');
	document.getElementById('inVolt1').innerHTML = jQuery.i18n.prop('volt');
	document.getElementById('inFreq1').innerHTML = jQuery.i18n.prop('freq');
	document.getElementById('input1').innerHTML = jQuery.i18n.prop('group.in');
	document.getElementById('input3').innerHTML = jQuery.i18n.prop('group.in');
	document.getElementById('inVolt3').innerHTML = jQuery.i18n.prop('volt');
	document.getElementById('inFreq3').innerHTML = jQuery.i18n.prop('freq');
	document.getElementById('btnLoad').innerHTML = jQuery.i18n.prop('group.load');
	document.getElementById('btnBat').innerHTML = jQuery.i18n.prop('group.bat');
}