var settings = app.getSettings();
var index;
var reloadEvtId; //定时重载事件ID
var lostCount = 0;
var subpages = ['detail-subpage-data.html', 'detail-subpage-alarm.html', 'detail-subpage-history.html', 'detail-subpage-control.html'];
var subpage_style = {
	top: '45px',
	bottom: '51px'
};
mui.plusReady(function() {
	var self = plus.webview.currentWebview();
	for (var i = 0; i < 4; i++) {
	var sub = plus.webview.create(subpages[i], subpages[i], subpage_style);
		if (i > 0) {
			sub.hide();
		}
		self.append(sub);
	}
    //当前激活选项
	var activeTab = subpages[0];
	//选项卡点击事件
	mui('.mui-bar-tab').on('tap', 'a', function(e) {
		var targetTab = this.getAttribute('href');
		if (targetTab == activeTab) {
			return;
		}
		//调用子页的显示初始化函数
    	mui.fire(plus.webview.getWebviewById(targetTab),'initShow',null);
		//显示目标选项卡
		plus.webview.show(targetTab);
		//隐藏当前;
		plus.webview.hide(activeTab);
		//更改当前活跃的选项卡
		activeTab = targetTab;
	});

	//返回上一页事件
	document.getElementById("back").addEventListener('tap', backToList);
	
	//自定义事件，页面初始化
    window.addEventListener('init',init);
   
	//自定义启动定时重载事件
    window.addEventListener('startReload',function(event){
    	//console.log("detail startreload");
 		app.setActiveView("detail");
    	reload();
		reloadEvtId = setInterval("reload()", 10000);  
	});
	window.addEventListener('stopReload',function(event){
		clearInterval(reloadEvtId);
    });
});

function gotoRealdataTab() {
	var defaultTab = document.getElementById("realtimeTab");
	//模拟首页点击
	mui.trigger(defaultTab, 'tap');
	//切换选项卡高亮
	var current = document.querySelector(".mui-bar-tab>.mui-tab-item.mui-active");
	if (defaultTab !== current) {
		current.classList.remove('mui-active');
		defaultTab.classList.add('mui-active');
	}
}
function init() {
    //获得事件参数
     //console.log("detail init");
    index = event.detail.index;
    reload();
	reloadEvtId = setInterval("reload()", 10000);  
	gotoRealdataTab();
	app.setActiveView("detail");
	lostCount = 0;
	settings = app.getSettings();
	app.updateLanguage(settings.lang, updateLanguage);
	//调用子页的初始化函数
	for (var i = 0; i < subpages.length; i++) {
    	mui.fire(plus.webview.getWebviewById(subpages[i]),'init',{index:index});
    }
}
function backToList() {
	//console.log("backtoList");
	clearInterval(reloadEvtId);
       //触发列表页面的startReload事件
	mui.fire(plus.webview.getWebviewById('list'), 'show', null);
	setTimeout(function() {
		mui.openWindow({
			id: 'list',
			"url":"list.html",
			show: {
				aniShow: 'pop-in'
			},
			waiting: {
				autoShow: false
			}
		});
	}, 0);
 						
	setTimeout(function() {
		mui.fire(plus.webview.getWebviewById('list'), 'startReload', null);
	}, 100);
	plus.webview.currentWebview().hide('auto');
}
function reload() {
   	//console.log("execute detail reload : "+plus.networkinfo.getCurrentType());
	var url = settings.url+'/'+index+'/detail?lang='+settings.lang;
	app.connect(url, success, error);
}
/**
* 成功响应的回调函数
*/
var success = function(response) {
	lostCount = 0;
	//设备已移除，退出到list页面
	if(response == null) {
		backToList();
		return;
	}
	updateUI(response);
	//console.log("ajax ok:"+JSON.stringify(response));
	//更新子页面
	var param = {"resp": response};
	for (var i = 0; i < subpages.length; i++) {
    	mui.fire(plus.webview.getWebviewById(subpages[i]),'updateUI',param);
    }
};
	
/**
* 失败响应的回调函数
*/
var error = function(result) {
	//console.log("detail error "+lostCount);
	lostCount++;
	if(lostCount >= 12) {
		mui.fire(plus.webview.getWebviewById('main'), 'reConnect', null);
	}
};

/**
* @param {Object} resp: ajax取得的新数据
*/
function updateUI(resp) {
	updateHeader(resp);
	//alarm
	var warnData = resp.warnData;
	if(warnData.length > 0) {
		document.getElementById("alarmNo").innerHTML=warnData.length;		
		document.getElementById("alarmNo").style.display="block";
	}else{
		document.getElementById("alarmNo").style.display="none";
	}
}

function updateHeader(resp) {
	var key = document.getElementById("key");
	if(key.innerHTML != resp.key) {
		key.innerHTML = resp.key;
		//device changed, clear control info
		mui.fire(plus.webview.getWebviewById(subpages[3]), 'onDeviceChanged', null);
	}
}




////////////////////////
function updateLanguage() {
	document.getElementById('titleDetail').innerHTML = jQuery.i18n.prop('title.detail');
	document.getElementById('menuRealtime').innerHTML = jQuery.i18n.prop('menu.realtime');
	document.getElementById('menuAlarm').innerHTML = jQuery.i18n.prop('menu.alarm');
	document.getElementById('menuHistory').innerHTML = jQuery.i18n.prop('menu.history');
	document.getElementById('menuControl').innerHTML = jQuery.i18n.prop('menu.control');
}



                
         
