var data = null; //设备列表JSON对象
var showInfoIndex = -1; //设备信息下标
var strInfo;//设备信息的Json字串，用于比较是否有变化
var settings = app.getSettings();
var reloadEvtId; //定时重载事件ID
//var checkWsEvtId; 
var lostCount = 0;
var onBackground = false; //是否在后台运行
mui.init({
	swipeBack: false,
	statusBarBackground: '#f7f7f7'
});
			
mui.plusReady(function() {
	//仅支持竖屏显示
	plus.screen.lockOrientation("portrait-primary");
	jQuery.ajaxSetup({cache:false});
				
	mui.preload({
		url:"detail.html",
		id:"detail",
	});

	//自定义初始化事件
	window.addEventListener('init',init);
	//自定义启动定时重载事件
    window.addEventListener('startReload',function(event){
    	//console.log("list startReload");
 		app.setActiveView("list");
    	reload();
		reloadEvtId = setInterval("reload()", 10000);  
	});
	window.addEventListener('stopReload',function(event){
		clearInterval(reloadEvtId);
    });
	window.addEventListener('stopWebSocket',function(event){
		ws.stop();
    });

	mui.back = function() {
		backToConnect();
	};
	
	document.addEventListener( "pause", onAppPause, false );
	document.addEventListener( "resume", onAppResume, false );
});

function init() {
	    //console.log("list init");
		app.setActiveView("list");
		lostCount = 0;
		//获得事件参数
		data = event.detail.data;
		settings = app.getSettings();
	 	app.updateLanguage(settings.lang, updateLanguage);
		createUI();
     	reload();
 		reloadEvtId = setInterval("reload()", 10000);  
 		ws.start();
 		console.log("ws start");//bethtest
}

function onAppPause() {
	onBackground = true;
	//console.log("onAppPause");
    mui.fire(plus.webview.getWebviewById('list'),'stopReload',null);
    mui.fire(plus.webview.getWebviewById('detail'),'stopReload',null);
}
function onAppResume() {
	onBackground = false;
	var view = app.getActiveView();
	//console.log("onAppResume "+view);
	if(view == "list") {
	    mui.fire(plus.webview.getWebviewById('list'),'startReload',null);
	}else if(view == "detail") {
	    mui.fire(plus.webview.getWebviewById('detail'),'startReload',null);
	}
}

function backToConnect() {
    mui.fire(plus.webview.getWebviewById('main'),'reConnect',null);
}

function reload() {
	//console.log("list network state: "+plus.networkinfo.getCurrentType());
	app.connect(settings.url+'/appList', success, error);
}
/**
* 成功响应的回调函数
*/
var success = function(response) {
	//console.log("list ajax: "+JSON.stringify(response));
	updateUI(response);
	lostCount = 0;
};
	
/**
* 失败响应的回调函数
*/
var error = function(result) {
	//console.log("ajax error:"+lostCount);
	lostCount++;
	if(lostCount >= 12) {
		backToConnect();
	}
};
			
/**
 * 跳转到详细数据页面
 */
function toDetail(index) {
	clearInterval(reloadEvtId);
    //触发详情页面的getIndex事件
    mui.fire(plus.webview.getWebviewById('detail'),'init',{
    	index:index
	});
	mui.openWindow({
		id:"detail",
		url:"detail.html",
		styles: {
			top: '45px',
			bottom: 0,
			bounce: 'vertical',
		}
	});
}
/**
* 隐藏UPS信息
*/
function hideInfo() {
	var info = document.querySelector('.xinxi');
	if(info) {
		info.parentNode.removeChild(info);
		info = null;
	}
}
//显示或隐藏下标为index的设备信息
function showInfo(index) {
	if(showInfoIndex >=0) {
		hideInfo();	
	}
	if(index != showInfoIndex) {
		var list = getList();
		var info = document.createElement("div");
		info.classList.add("xinxi");
		info.innerHTML = getXinxiHtml(data[index]);
		if(index == list.childElementCount-1) {
			//为最后一个设备
			list.appendChild(info);
		}else {
			list.insertBefore(info, list.childNodes[index+1]);
		}
		showInfoIndex = index;
		strInfo = JSON.stringify(data[index]);
	} else {
		showInfoIndex = -1;
	}
}
/**
* 更新UPS信息
* @param {Object} d ：UPS的json数据 
*/
function updateInfo(d) {
	var info = document.querySelector('.xinxi');
	if(info) {
		info.innerHTML = getXinxiHtml(d);
	}
	strInfo = JSON.stringify(d);
}
function createUI() {
	var list = getList();
	list.innerHTML = "";
	var i = 0;
	var d = data[0];
	while(d) {
		addChild(list, d, i);
		d = data[++i];
	}
}
			
function getList() {
	return 	document.getElementById('list');
}
			
function getDevices() {
	return document.querySelectorAll('.wrapper');
}
			
/**
* 把单个设备添加到父节点
* @param {Object} pNode ： 父节点
* @param {Object} d ：单个设备的json数据
* @param {Object} i ：设备的下标
*/
function addChild(pNode, d, i) {
	var dev = document.createElement("div");
	dev.classList.add('wrapper');
	dev.innerHTML = getDevHtml(d, i);
	pNode.appendChild(dev);
}
			
/**
* 为实现无回滚无闪烁更新，先比较数据有变化才更新界面 
* @param {Object} resp: ajax取得的新数据（1台设备）
*/
function updateUI(resp) {
	var i = 0;
	var d = null;
	if(data != null && data.length != 0) {
	    d = data[i];
	}
	var n = resp[i];
	var html = '';
	var dev = null;
	while(d && n) {
		if(d.key != n.key
			|| d.img != n.img
			|| d.color != n.color) {
			dev = document.getElementById('dev'+i);
			html = getDevChildHtml(n,i);
			dev.innerHTML = html;		
		}
		i++;
		d = data[i];
		n = resp[i];
	}
	j = i;
	var list = getList();
	if(d) {
		//data的总节点数存于j
		while(d) {
			d = data[++j];
		}
		//删除所有多余节点
		var devices = getDevices();
		for(p=j;p>i;p--) {
			list.removeChild(devices[p-1]);
		}
	}else if(n) {
		//增加新节点
		while(n) {
			addChild(list, n, i)
			n = resp[++i];
		}
	}
	if(showInfoIndex >= 0) {
		if(showInfoIndex < i) {
		//有变化才更新
			if(strInfo != JSON.stringify(resp[showInfoIndex]))
				updateInfo(resp[showInfoIndex]);
		}else {
			//设备节点已删除
			hideInfo();
			showInfoIndex = -1;
		}
	}
	data = resp;
}
			
function getDevHtml(d,i) {
	var html = '<div id="dev'+d.id+'" class="container1">';
	html += getDevChildHtml(d,i);
	html += '</div>';
	return html;
}
			
function getDevChildHtml(d,i) {
	html = '<div class="my_ups2 bg_'+d.color+'">';
	html +=	'<p><a class="my_sb" onclick="showInfo('+i+');" href="#"><span>'+(i+1)+'</span><br>UPS</a></p>';
	html +=	'<div class="arrow-right a2 bd_'+d.color+'"></div>';
	html += '</div>';
	html += '<div class="my_ups1" onclick="toDetail('+d.id+');"><a href="#" >'+d.key+'</a>'; 
	html +=	'<img class="status_img" src="images/'+d.img+'.png">'; 
	html += '</div>';
	return html;				
}
			
function getXinxiHtml(d) {
	var html = '<p>'+jQuery.i18n.prop('model')+'：'+d.model+'</p>';
	html += '<p>'+jQuery.i18n.prop('input')+'：'+d.in+'</p>';
	html += '<p>'+jQuery.i18n.prop('output')+'：'+d.out+'</p>';
	html += '<p>'+jQuery.i18n.prop('group.load')+'： '+d.load+'</p>';
	return html;
}

function updateLanguage() {
}
