/**
 * 现实推送的WebSocket处理
 **/
(function($, owner) {
	var _ws;
	var reconnectCounter = 0;
    var timerId; 
    var setConnect = false;
	/**
	 * 获得ws url地址
	 **/
	owner._getUrl = function() {
		return app.getSettings().url.replace("http","ws")+"/servlet/a";
	};
	
	/**
	 * 启动
	 */
	owner.start = function() {
		owner.stop();
		owner.connect();
		setConnect = true;
		reconnectCounter = 0;
		timerId = setInterval("onTimer()", 60000);  // 120000->60000
	}
	
	/**
	 * 停止
	 */
	owner.stop = function() {
		setConnect = false;
		owner.disconnect();
		clearInterval(timerId);
	}
	
	onTimer = function() {
   		//plus.push.createMessage("onTimer", "LocalMSG", {cover:false} );
   		//console.log("onTimer setConnect="+setConnect+" reconnectCounter="+reconnectCounter);
   		if(setConnect) {
	   		if(reconnectCounter++ >= 4) {
	   			owner.disconnect();
	   			owner.connect();
   				//plus.push.createMessage("ws reconnect", "LocalMSG", {cover:false} );
   				//console.log("ws reconnect");
   				reconnectCounter = 0;
	   		}
   			
   		}
   		
	}
	
	/**
	 * 连接请求
	 **/
	owner.connect = function() {
		var url = owner._getUrl();
		url += "?uuid="+plus.device.uuid;
		//console.log("url:"+url);
		if ('WebSocket' in window) {
            owner._ws = new WebSocket(url);
        } else if ('MozWebSocket' in window) {
            owner._ws = new MozWebSocket(url);
        } else {
            return;
        }
        owner._ws.onopen = owner._onopen;
        owner._ws.onmessage = owner._onmessage;
        owner._ws.onclose = owner._onclose;
        owner._ws.onerror = owner._onerror;
	};

	/**
	 * 中断连接请求
	 **/
	owner.disconnect = function() {
		if(owner._ws == null)
			return;
        owner._ws.close();
        owner._ws = null;
	}

	owner._onopen = function() {
		//console.log("onopen");
    };

	owner._onmessage = function(m) {
        if (m.data) {
       		//console.log("recv:"+m.data);
       		reconnectCounter = 0;
        	var arr = m.data.split(",");
        	if(arr.length != 4)
        		return;
        	var msg = jQuery.i18n.prop('event.'+arr[3]);
        	var content = arr[2]+' | '+arr[1]+' '+arr[0]; 
        	if(plus.os.name == 'iOS'){
        		//iOS cannot set title
        		content = msg+' | '+content;
			}else {
				var msgs = plus.push.getAllMessage();
				for(i=49;i<msgs.length;i++) {
					plus.push.remove(msgs[i-49]);
				}
			}
    		plus.push.createMessage(content, "LocalMSG", {cover:false, title: msg} );
        }
    };

    owner._onclose = function(m) {
		//console.log("onclose ");
        owner._ws =null;
//      if(onBackground) {// && reconnectCounter <= 5) {
//      	setTimeout(owner.reconnect,10000);
//      }
    };
    
    owner._onerror = function(m) {
		console.log("onerror="+m);
    };
    
//  owner.reconnect = function() {
//  	console.log("reconnect onBackground="+onBackground+";owner._ws="+owner._ws);
//  	if(!onBackground || owner._ws != null) {
//  		return;
//  	}
//  	//reconnectCounter++;
//  	owner.connect();
//  };
    
    owner.getState = function() {
    	if(owner._ws == null)
    		return 4;
    	return owner._ws.readyState;	
    };

}(mui, window. ws = {}));